package com.sitemesh.taglib.decorator;

import com.sitemesh.HTMLPage;
import com.sitemesh.taglib.AbstractTag;
import javax.servlet.jsp.JspException;

/**
 * Write the HTMLPage <code>&lt;title&gt;</code> value to out.
 *
 * @author <a href="joe@truemesh.com">Joe Walnes</a>
 * @version $Revision: 1.2 $
 *
 * @see com.sitemesh.HTMLPage#getTitle()
 */
public class TitleTag extends AbstractTag {

	private String defaultTitle;

	/**
	 * Value to write if no title is found (optional).
	 */
	public void setDefault( String defaultTitle ) {
		this.defaultTitle = defaultTitle;
	}

	public int doEndTag() throws JspException {
		try {
			HTMLPage htmlPage = ( HTMLPage )getPage();
			String title = htmlPage.getTitle();
			if ( title == null || title.length() == 0 ) title = defaultTitle;
			pageContext.getOut().print( title );
		}
		catch ( Exception e ) {
			trace( e );
		}
		return EVAL_PAGE;
	}

	public void release() {
		defaultTitle = null;
		super.release();
	}

}
